// hello.cpp - implementation of CHelloWindow
#include <afxwin.h>
#include <process.h>
#include "TrainOS.h"
//from Mr. Blahnik
#include "cstrtok.cpp"
#include "Getint.cpp"

#include "ResourceManager.h"
#include "ccr.h"
#include "DCC_comm.h"
#include "MyDcc.h"


/*****************************************
Manages the PhotoCells: Checks the current status of the cells
checks if the train is in the middle of coing over a cell.  It does this 
through CellCount[].  It updates the current status of the cells in CellList[].
*/
void CTrainOS::Deallocate(int c){
	
	if(CellAllocation[c]==2){//was allocated to something else(not the train)
		CellAllocation[c]=0;//photocell cleared and is ok to move toward
		CellCount[c]=0;
		if(Blocked==c){//give it to the train that was blocked on this cell
			CellAllocation[c]=1;
			Blocked=-1;
			t.Blocked=false;
		}
		
		
	}
	else if(CellCount[c]>=t.GetLength()){
		if(t.PCLast!=t.PCNext){//must have switched dirs for this to happen
								// don't want to deallocate what we are going toward
			//MessageBox("Deallocate");
			CellCount[t.PCLast]=0;//train is done with previous cell cell
			log << "Deallocated cell: " << t.PCLast << endl;
			CellAllocation[t.PCLast]=0;
			t.PCLast=c;
			/*for(int i=0;i<NUMCELL;i++){
				if(CellAllocation[i]==1)
					if(i!=t.PCHas &&i!=t.PCNext){//clean up photocells that have been missed
						CellAllocation[i]=0;
						CellCount[i]=0;
					}
			}*/
		}
		t.PCLast=c;

	}
	else{
		log << "Didn't deallocate cell: " << t.PCLast << " because count on cell " << 
			c << " was only " << CellCount[c] << endl;
	}
	if(Blocked==c)
	{
		Blocked=-1;//not blocked anymore...resource freed up
		CellAllocation[c]=1;//allocate cell to train
	}


}

//looks to alocate the next cell given an input of the current cell the train is over
//returns true if sucessful;
//or false if not and blocks the train



void CTrainOS::ResourceManager(){
int c;
	int Speed, PC, Dir, Instr, CellAct[NUMCELL];
	bool ok, ExecuteOk=true, Change=false, c1=false;
	//gets the current state of each photocell
	int i;
	
	
	for(c=0;c<NUMCELL;c++){//get a snap shot of photocells
		CellCurList[c]=Get_Sensor_Status(c);
	}

	for(c=0;c<NUMCELL;c++){//adjust counts here for new cars hitting cells;
		if(CellCurList[c]==1 && CellList[c]==0){//if a car just hit a cell
			if (CellAllocation[c]==1){//if that cell was the trains cell
				CellCount[c]++;//increase the count for that cell
				log << "count++ for cell: " << c << endl; 
				c1=true;
			}
		}
	}

	if(c1){
		log << "after getting snap shot\nCur Cell List: ";
		for(c=0;c<NUMCELL;c++)
			log << CellCurList[c] << " ";
		log << endl;
	}
	for(c=0;c<NUMCELL;c++){
		//i=Get_Sensor_Status(c);
		//CellAct[c]=i;
		//*******check to see if the cell is allocated to the train****
		//if(i==CellList[c]);
		if(CellCurList[c]!=CellList[c]){// || Instr==2){//see if the cell state changed or train is asleep
			Change=true;
			if(CellCurList[c]==0){//cleared a photocell
				
				/*if(!CheckCars()){
					MyDCC_motor(t.ID, t.Direction, 0);
					KillTimer(1);
					MessageBox("A car has become uncoupled","Error!");
				}*/

				log << "Car just left photocell: " << c << endl;
				Deallocate(c);//if count is correct, can deallocate the previous cell
				//log << "\nAfter Deallocatethe instr is: ";
				//log << "PCLast: " << t.PCLast << " PCHas: " << t.PCHas << endl;
			//	log << " PCNext: " << t.PCNext << endl;
						//	log << "Requested photocell #: " << PC << endl << endl; 

				if(Blocked==-1){
					ExecuteOk=ExecuteInstr(t.Speed, t.PCNext, t.Direction, t.Instr);
					//MyDCC_motor(t.ID, t.Direction, t.Speed);
				}

			}
			else if(CellCurList[c]==1){
				if (CellAllocation[c]==1){//check to see if it is my cell
					//CellCount[c]++;//increase count for that cell
					log << "After count++" << endl;
					Display_Arrays();
					if(CellCount[c]==1){//new train over the cell
						log << endl;
						Display_Arrays();
						log << "Hit Photocell #: " << c << endl;
						//t.PCLast=t.PCHas;
						t.PCHas=c;
						log << "PCLast: " << t.PCLast << " PCHas: " << t.PCHas << endl;
						log << "t.Instr= " << t.Instr << "right before the check\n";
						if(t.Instr==2)//Instr to uncouple
							Uncouple();
						if(t.Instr==3)
							Couple();
						ok=GetNextInstr(Speed, PC, Dir, Instr);//where to next? ie speed 4 phococell 6
						if(ok){
							t.PCNext=PC;
							t.Instr=Instr;
							log << " PCNext: " << t.PCNext << endl;
							log << "Requested photocell #: " << PC << endl; 
							if(Instr!=1)
								ExecuteOk=ExecuteInstr(Speed, PC, Dir, Instr);//can I go there?
							/*else if(Instr==1){
								MyDCC_motor(t.ID, t.Direction, 0);
								log << "In Instr==1.  Should be sleeping here\n";
								Sleep(Speed);	//pause for the given time 
												//and then get next instr
								GetNextInstr(Speed, PC, Dir, Instr);
								t.PCNext=PC;
								t.Speed=Speed;
								t.Direction=Dir;
								t.Instr=Instr;
							}*/
							
							
							//MessageBox("after execute","");
						}
						else{
							MessageBox("batch ran out", "Bah!!!");
							log << "Can't get another Instruction" << endl;
							MyDCC_motor(t.ID, t.Direction, 0);
						}
					}
					
					log << "new car just hit photocell: " << c << endl;
					log << "Photocell count for cell: " << c << " is: " << CellCount[c] << endl;
				}//end if CellAllocation[c]==1)
				else{ 
					CellAllocation[c]=2;
					//******************other train over photocell***************
					//GetOtherDir(); //figure out which dir the other engine(GHOST) is going
					//AllocateOther();	//allocate possible photoS for the other engine
					//DeallocateOther();//deallocate ones the engin is not using anymore

				}//******************************************************
			
			}//end else if(i==1)
			
		}//end if(i!=CellList[c])
		
		//CellList[c]=i;
	}//end for
	for(c=0;c<NUMCELL;c++)
		CellList[c]=CellCurList[c];
	//display of arrays for now
	x="";
	y="";
	z="";
	char s[10];
	char u[10];
	
	
	for (c=0;c<NUMCELL;c++){
		itoa(CellList[c],s,10);
		x+=s[0];
		x+=' ';
		itoa(CellCount[c],u,10);
		y+=u[0];
		y+=' ';
		itoa(CellAllocation[c],u,10);
		z+=u[0];
		z+=' ';
	}
	if(Change){
		log << endl << "Index:      ";
		for(c=0;c<NUMCELL;c++){
			log << c << " ";
		}
		log << endl << "Cell State: ";
		for(c=0;c<NUMCELL;c++){
			log << CellList[c];
			if(c<10)log << " ";
			else log << "  ";
		}
		log << endl << "Cell Count: ";
		for(c=0;c<NUMCELL;c++){
			log << CellCount[c];
			if(c<10)log << " ";
			else log << "  ";
		}
		log << endl << "Cell Alloc: ";
		for(c=0;c<NUMCELL;c++){
			log << CellAllocation[c];
			if(c<10)log << " ";
			else log << "  ";
		} 
		log << endl;
	}
	
	return;
}// end CellManager()

bool CTrainOS::GetNextInstr(int & Speed, int & PC, int & Dir, int & Instr){
	bool ok;
	string token;
	string Temp;
	//MessageBox("GetNextInstr","");
	//read cell then speed then dir
	if(BatchUsed>=BatchCount)BatchUsed=0;
	if(BatchUsed<BatchCount){
		Temp=Batch[BatchUsed];
		token=cstrtok(Temp," ");
		PC =Getint(token, ok);
		token=cstrtok(Temp," ");
		Speed =Getint(token, ok);
		token=cstrtok(Temp," ");
		Dir =Getint(token, ok);
		token=cstrtok(Temp," ");
		Instr =Getint(token, ok);
		BatchUsed++;
		log << "instruction gotten: " << BatchUsed-1 << endl;
		log << "pc: " << PC << "  speed: " << Speed << "  dir: " << Dir 
			<< " Instr: " << Instr << endl; 
		return true;
	}
	return false;

}

bool CTrainOS::ExecuteInstr(int Speed, int pc, int Dir, int Instr){
	bool state;
	/*************************************************************************************
	/* Start debugging here...The OS will not switch the turnouts correctly, some will. 
	a simple outside loop, TO 3 will turn, but 4 won't.  aiming for the figure 8, t2 will 
	not turn when the train goes over it the second time.
	*******************************************************************************/
	log << "PCLast: " << t.PCLast << " PCHas: " << t.PCHas << " PCNext: " << t.PCNext << endl;
	t.Instr=Instr;
	
	if(t.Direction!=Dir){
			log << endl << "****** Change Dir *******" << endl;
				//stop train
				MyDCC_motor(t.ID, t.Direction, 0);
				t.Direction=Dir;
				//CellAllocation[t.PCLast]=0;
				//t.PCLast=-1;
				Display_Arrays();
				log << endl;
				for(int i=0;i<NUMCELL;i++){
					if(CellCount[i]!=0){
						if(i==t.PCHas)
							CellCount[i]=t.Length-(CellCount[i]-1);
						else if(CellList[i]==1){
							log << i << " ";
							CellCount[i]=t.Length-(CellCount[i]-1);
						}
						else
							CellCount[i]=t.Length-(CellCount[i]);
						if(CellCount[i]<0)CellCount[i]=0;
					}
				//	if(i==t.PCHas) CellCount[i]=t.Length-(CellCount[i]-1);
				}
				log << endl;
				Display_Arrays();
				bool ok=true;
				while(CellCount[t.PCNext]!=0 && ok){
					t.PCHas=t.PCNext;//make it as if the train had just hit the cell
					ok=GetNextInstr(Speed, pc, Dir, Instr);
					t.PCNext=pc;
					t.Speed=Speed;
					t.Direction=Dir;
					t.Instr=Instr;
				}
				if(!ok) MessageBox("error on change direction");
				//temp=CellCount[t.PCLast];
				//CellCount[t.PCLast]=CellCount[t.PCNext];
				//CellCount[t.PCNext]=temp;
				Sleep(1500);//sleeps the train to allow it to stop before changing direction
				log << "PCLast: " << t.PCLast << " PCHas: " << t.PCHas << " PCNext: " << t.PCNext << endl;
				log << "END Change Direction\n";
			}
	if(CellAllocation[pc]==0 || CellAllocation[pc]==1){
		if(t.Direction==1){
			if(Trackcw[t.PCHas][0]==pc){//found on track next
				
				if(Trackcw[t.PCHas][2]!=-1){//if there is a turnout, change it to on
					Turn_TO_On(Trackcw[t.PCHas][2]);
					//TO_On(Trackcw[t.PCHas][2]);
					//log << "Toggled ON TO: " << Trackcw[t.PCHas][2] << endl; 
				}

				CellAllocation[pc]=1;//give the train the cell
			}
			else if(Trackcw[t.PCHas][1]==pc){//found on other brantch of track next
				
				//turn turnout to off
				if(Trackcw[t.PCHas][2]!=-1){//if there is a turnout, change it to off
					MyDCC_motor(t.ID, t.Direction, 0);
					Turn_TO_Off(Trackcw[t.PCHas][2]);
					//TO_Off(Trackcw[t.PCHas][2]);
					//log << "Toggled OFF TO: " << Trackcw[t.PCHas][2] << endl;
				}

				CellAllocation[pc]=1;
			}//else MessageBox("didn't allocate","");

		}else if(t.Direction==0){
			if(Trackcc[t.PCHas][0]==pc){//found on track next
				log << endl << "in Trackcc[t.PCHas][0]==pc)" << endl;
				//turn turnout to left
				if(Trackcc[t.PCHas][2]!=-1){//if there is a turnout, change it to the left
					Turn_TO_On(Trackcc[t.PCHas][2]);
					log << "Toggled ON TO: " << Trackcc[t.PCHas][2] << endl; 
				}
				CellAllocation[pc]=1;//give the train the cell
			}else if(Trackcc[t.PCHas][1]==pc){//found on other brantch of track next
				log << endl << "in Trackcc[t.PCHas][1]==pc)" << endl;
				//turn turnout to right
				if(Trackcc[t.PCHas][2]!=-1){//if there is a turnout, change it to the left
					
					Turn_TO_Off(Trackcc[t.PCHas][2]);
					log << "Toggled OFF TO: " << Trackcc[t.PCHas][2] << endl;
				}
				CellAllocation[pc]=1;
			}else log << "can't fine the photocell" << endl;
		}

			
		
		
		t.Speed=Speed;
		state= true; //train executed the instruction
		log << "Train ID: " << t.ID << " Direction: " << //log output
			t.Direction << " Speed: " << t.Speed << endl;
		MyDCC_motor(t.ID, t.Direction, t.Speed);

	}else if (CellAllocation[pc]==2){//something else has the cell
		t.Blocked=true;
		Blocked=pc;
		//stop train
		MyDCC_motor(t.ID, t.Direction, 0);
		//MessageBox("Blocked in exeinstr","");

		log << "Train Blocked on Photocell #: " << pc << endl;
		log << "Train ID: " << t.ID << " Direction: " << //log output
			t.Direction << " Speed: " << t.Speed << endl;
		//BatchUsed--;
		//if (BatchUsed==-1)
		//	BatchUsed=BatchCount;
		log << "BatchUsed: " << BatchUsed << endl;
		log << "Dir: " << Batch[BatchUsed] << endl;
		Blocked=pc;//set which pc blocked the train
		state= false; //couldn't execute the instruction, the train is blocked
	}	
	return state;
}

CTrainOS::CTrainOS()
{
	bool ok;
	Create(NULL, "Train OS", WS_OVERLAPPEDWINDOW,
		CRect(100, 100, 700, 800) );
	

	int PortStatus = Open_Ports(); 
	//open ports to communicate with photocells and turnouts

	int InitStatus = Initialize_Board(1, 0, 0, 0, 0);
	InitStatus = Initialize_Board(2, 1, 1, 1, 1);
	InitStatus = Initialize_Board(3, 1, 1, 1, 1);
    InitStatus = Initialize_Board(4, 1, 1, 1, 1);
	//Init the four green boards with the photocells and turnouts
	//starts the turnouts in correct default positions.	
	
	MyDCC_open("COM1");
	MyDCC_reset();

	for(int i=0;i<NUMCELL;i++){
		CellList[i]=0;
		CellCount[i]=0;
		CellAllocation[i]=0;
		CellCurList[i]=0;
	}

	ifstream fin;
	
	log.open("logfile.txt");
	fin.open("path.txt");
	if(!fin){
		MessageBox("File cannot be opened","");
	}else{
		BatchCount=0;
		while(!fin.eof()){
			getline(fin, Batch[BatchCount]);
			BatchCount++;
		}
		BatchUsed=0;
		fin.close();
	}
	log << "Number of intruuctions loaded: " << BatchCount << endl;
	ok=LoadTrack();
	if (!ok) MessageBox("Couldn't load file","");
	/**/ 
	CellAllocation[0]=1;//start going toward cell 0
	CellAllocation[8]=1;
	//CellAllocation[13]=1;
	CellCount[8]=4;
	//CellCount[13]=1;
	//CellAllocation[7]=2;
	
	count=0;
	
	t.ID=32;
	t.PCHas=8;
	t.PCLast=8;
	//t.PCLast=13;
	t.PCNext=0;
	t.Speed=4;
	t.Direction=1;
	t.Instr=0;
	MyDCC_motor(t.ID, t.Direction, t.Speed);//start the train
	/*for(int p=0;p<5;p++){
	TO_Off(p);
	
	}
	Sleep(1500);for(p=0;p<5;p++)log << Get_TO_Status(p) << " ";
	log << endl;*/
 SetTimer(1,100, NULL);
	
	
}

CTrainOS::~CTrainOS()
{
	MyDCC_motor(t.ID, t.Direction, 0);
	log.close();
	KillTimer(1);
	MyDCC_close();
	
}

void CTrainOS::OnTimer(UINT x){
	ResourceManager();
//	AlocationManager();
	
	
	
	//count++;
	Invalidate();

}

void CTrainOS::OnPaint(){
	char tl[10],td[10],ts[10],ti[10], tc[10];
	int PC=-1, Speed=-1, Dir=-1, Instr=-1;
	bool ok1, ok2;

	CPaintDC dc (this);
	//*******************Train info**********
	itoa(t.Length,tl,10);
	itoa(t.Direction,td,10);
	itoa(t.Speed,ts,10);
	itoa(t.ID,ti,10);
	dc.TextOut(100,100,"Train Length---= ");
	dc.TextOut(100,120,"Train Speed----= ");
	dc.TextOut(100,140,"Train Direction= ");
	dc.TextOut(100,160,"Train ID-------= ");
	dc.TextOut(200,100, tl[0]);
	dc.TextOut(200,120, ts);
	dc.TextOut(200,140, td);
	dc.TextOut(200,160, ti);
	//****************************************

	//Photocell info
	dc.TextOut(100,200,"Cell State:      ");
	dc.TextOut(100,230,"Cell Count:      ");
	dc.TextOut(100,260,"Cell Allocation: ");
	dc.TextOut(200, 200, x);
	dc.TextOut(200, 230, y);
	dc.TextOut(200, 260, z);
	
	//ok1=GenerateDisInstr(PC, Speed, Dir, Instr, BatchUsed);
	//if(ok1){
		itoa((BatchUsed),tc,10);
		itoa(t.PCNext,tl,10);
		itoa(t.Speed,td,10);
		itoa(t.Direction,ts,10);
		itoa(t.Instr,ti,10);
		dc.TextOut(100,350, "Current Instruction");
		//dc.TextOut(250,350, tc);
		dc.TextOut(100, 400,"PC:          ");
		dc.TextOut(200, 400, tl);
		dc.TextOut(100, 420,"Speed:       ");
		dc.TextOut(200, 420, td);
		dc.TextOut(100, 440,"Direction:   ");
		dc.TextOut(200, 440, ts);
		dc.TextOut(100, 460,"Instruction: ");
		dc.TextOut(200, 460, ti);
	//}else log << "failed to display instr\n";

	ok2=GenerateDisInstr(PC, Speed, Dir, Instr, BatchUsed+1);
	if(ok2){
		itoa(BatchUsed+1,tc,10);
		itoa(PC,tl,10);
		itoa(Speed,td,10);
		itoa(Dir,ts,10);
		itoa(Instr,ti,10);
		dc.TextOut(300, 350, "Next Instruction");
		//dc.TextOut(450, 350,tc);
		dc.TextOut(300, 400,"PC:          ");
		dc.TextOut(400, 400, tl);
		dc.TextOut(300, 420,"Speed:       ");
		dc.TextOut(400, 420, td);
		dc.TextOut(300, 440,"Direction:   ");
		dc.TextOut(400, 440, ts);
		dc.TextOut(300, 460,"Instruction: ");
		dc.TextOut(400, 460, ti);
	}else log << "failed to display instr1\n";
		dc.TextOut(100, 500, "BatchUsed");
		itoa(BatchUsed,tl,10);
		dc.TextOut(200, 500, tl);
		dc.TextOut(100, 520, "BatchCount");
		itoa(BatchCount,tl,10);
		dc.TextOut(200, 520, tl);
	//dc.TextOut(count, count, "hello");
}

bool CTrainOS::LoadTrack(){
	ifstream fin;
	ofstream fout;
	int temp;
	fout.open("test.txt");
	
	int i;
	fin.open("track.dat");
	if(!fin)
		return false;
	for(i=0;i<NUMCELL;i++){
		fin >> temp;
		Trackcw[i][0]= temp;
		fin >> temp;
		Trackcw[i][1] = temp;
		fin >> temp;
		Trackcw[i][2]= temp;
		}
	for(i=0;i<NUMCELL;i++){
		fin >> Trackcc[i][0] >> Trackcc[i][1] >> Trackcc[i][2];
		}

	for (i=0;i<NUMCELL;i++)
		fout << i << " " << Trackcw[i][0] << " " << Trackcw[i][1] << " " << Trackcw[i][2] << endl;
	for (i=0;i<NUMCELL;i++)
		fout << i << " " << Trackcc[i][0] << " " << Trackcc[i][1] << " " << Trackcc[i][2] << endl;
	//return true;

	fout.close();
	fin.close();
	return true;
}
void CTrainOS::Turn_TO_On(int Cell){
	bool ok;
	ok=false;
	switch(Cell){
		case 0:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 1:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 2:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 3:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 4:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		default:
			ok=false;
			break;
		}
	if(!ok)
		MyDCC_motor(t.ID, t.Direction, 0);//stop the train
	TO_On(Cell);
	while(!ok){
		switch(Cell){
		case 0:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 1:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 2:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 3:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 4:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		default:
			ok=false;
			break;
		}
	}
MyDCC_motor(t.ID, t.Direction, t.Speed);//start the train


	log << "Toggled ON TO: " << Trackcw[t.PCHas][2] << endl;
}
void CTrainOS::Turn_TO_Off(int Cell){
	bool ok;
	ok=false;
	switch(Cell){
		case 0:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 1:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 2:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 3:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 4:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		default:
			ok=false;
			break;
		}
	if(!ok)
		MyDCC_motor(t.ID, t.Direction, 0);//stop the train
	TO_Off(Cell);
	while(!ok){
		switch(Cell){
		case 0:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 1:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 2:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 3:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 4:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		default:
			ok=false;
			break;
		}
	}
MyDCC_motor(t.ID, t.Direction, t.Speed);//start the train


	log << "Toggled ON TO: " << Trackcw[t.PCHas][2] << endl;
}

bool CTrainOS::Uncouple(){
	//MessageBox("uncoupleing");
	log << "\n\n**UNCOUPLING**\n\n";
	log << "t.PChas: " << t.PCHas << " t.direction: " << t.Direction << endl;
	
	//if(t.Direction==1)
	//	log << "Ileagle direction for uncoupling\n";
	//	return false;
	MyDCC_motor(t.ID, t.Direction, 0);//stops the train
	log << "train stoped\n";
	Sleep(5000);//make sure the train is stopped 
	MyDCC_motor(t.ID, 1, 3);
	Sleep(1000);
	log << "train moved forward\n";
	MyDCC_motor(t.ID, 0, 0);
	Sleep(1500);
	MyDCC_motor(t.ID, 0, 2);//push the uncoupled car
	log << "train moves backward\n";
	
		/*loop till I get one car past the photocell, then stop, change dirs and get back to origional cell
		uncoupling should be finnished, subtract one from train length*/
	int temp;
	temp=Get_Sensor_Status(t.PCHas);
	//log << "temp= " << temp;
	while(temp!=0){
	
		temp=Get_Sensor_Status(t.PCHas);
		//log << " " << temp;
	}
	log << endl;
	MyDCC_motor(t.ID, 1,0);
	//Sleep(100);
	//MyDCC_motor(t.ID, 0, 4);
	t.Length--;
	log << "\nDONE WITH UNCOUPLING\n";
	//if(CellCount[t.PCHas]==t.Length+1)CellCount[t.PCHas]--;
	return true;
}

bool CTrainOS::Couple(){
	
	int i,temp;
	//MessageBox("uncoupleing");
	log << "\n\n**COUPLING**\n\n";
	log << "t.PChas: " << t.PCHas << " t.direction: " << t.Direction << endl;
	
	//if(t.Direction==1)
	//	log << "Ileagle direction for uncoupling\n";
	//	return false;
	
	//MyDCC_motor(t.ID, 0, 4);//tries to recouple the car
	//Sleep(1000);
	//log << "train moves backward\n";
	MyDCC_motor(t.ID,0,2);
	Sleep(500);
	t.Length++;//updated the length
	log << "Updating counts\n";
	Display_Arrays();
	
	Display_Arrays();
	MyDCC_motor(t.ID,1,0);
	Sleep(1000);
	
	for(int c=0;c<NUMCELL;c++){	//updated the counts 
								//on other cells to reflect the new train length
		if(CellCount[c]>0 && c!=t.PCHas)
			CellCount[c]++;
	}
	
	MyDCC_motor(t.ID,1,2);
	i=Get_Sensor_Status(t.PCHas);
	if(i==1){
		temp=Get_Sensor_Status(t.PCHas);
		log << "backup while train is over cell\n";
		while(temp!=0){
			temp=Get_Sensor_Status(t.PCHas);
		}
		log << "back up till last car is back over cell.\n";
		temp=Get_Sensor_Status(t.PCHas);
		while(temp==0){
			temp=Get_Sensor_Status(t.PCHas);
		}
	}
	else if(i==0){
		temp=Get_Sensor_Status(t.PCHas);
		while(temp==0){
			temp=Get_Sensor_Status(t.PCHas);
		}
	}
	
	//Sleep(500);
		/*loop till I get one car past the photocell, then stop, change dirs and get back to origional cell
		uncoupling should be finnished, subtract one from train length*/
	//MyDCC_motor(t.ID,1,4);
	//MyDCC_motor(t.ID, 1,0);
	//Sleep(100);
	MyDCC_motor(t.ID, 1, 0);
	log << "\nDONE WITH COUPLING\n";
	//if(CellCount[t.PCHas]==t.Length+1)CellCount[t.PCHas]--;
	return true;
}

void CTrainOS::Display_Arrays(){
	int c;
	log << endl << "Index:      ";
		for(c=0;c<NUMCELL;c++){
			log << c << " ";
		}
		
		log << endl << "Cell State: ";
		for(c=0;c<NUMCELL;c++){
			log << CellList[c];
			if(c<10)log << " ";
			else log << "  ";
		}
		log << endl << "Cell Count: ";
		for(c=0;c<NUMCELL;c++){
			log << CellCount[c];
			if(c<10)log << " ";
			else log << "  ";
		}
		log << endl << "Cell Alloc: ";
		for(c=0;c<NUMCELL;c++){
			log << CellAllocation[c];
			if(c<10)log << " ";
			else log << "  ";
		} 
		log << endl;
}
bool CTrainOS::GenerateDisInstr(int & PC, int & Speed, int & Dir, int &Instr, int Num){
bool ok;
//int PC, Speed, Dir, Instr;
	string token;
	string Temp;
	Num--;
	if(Num<0)Num=BatchCount;
	//MessageBox("GetNextInstr","");
	//read cell then speed then dir
	//if(Num<0)Num=BatchCount-1;
	//if(Num=BatchCount)Num=0;
	if(Num>BatchCount) Num=0;
	
		Temp=Batch[Num];
		token=cstrtok(Temp," ");
		PC =Getint(token, ok);
		token=cstrtok(Temp," ");
		Speed =Getint(token, ok);
		token=cstrtok(Temp," ");
		Dir =Getint(token, ok);
		token=cstrtok(Temp," ");
		Instr =Getint(token, ok);
		return true;
}

afx_msg void CTrainOS::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags){
	if(nChar== ' ')MyDCC_motor(t.ID, t.Direction, 0);
	if(nChar=='\r')MyDCC_motor(t.ID, t.Direction, t.Speed);

}
/**************************
	There is a large assumption that no car 
	can cover two cells at once.

  returns true if all is ok
  returns false if three cells in a row have the same count
				ie there is a car uncoupled
  ************************/
bool CTrainOS::CheckCars(){
	int t1=0, t2=15, t3=-1;//to store the counts of consecutive photocells
	bool done=false;

	t3=t.PCHas;
	//t1=t2;
	//t2=t3;
	while(!done){
			done=true;
			if(t.Direction==1){
				if(Trackcc[t3][0]!=-1)
					if(CellAllocation[Trackcc[t3][0]]==1){
						t1=t2; t2=t3; t3=Trackcc[t3][0];
						done=false;
					}
				if(Trackcc[t3][1]!=-1)
					if(CellAllocation[Trackcc[t3][1]]==1){
						t1=t2; t2=t3; t3=Trackcc[t3][0];
						done=false;
					}	

			}else if(t.Direction==0){
				if(Trackcw[t3][0]!=-1)
					if(CellAllocation[Trackcw[t3][0]]==1){
						t1=t2; t2=t3; t3=Trackcw[t3][0];
						done=false;
					}
				if(Trackcw[t3][1]!=-1)
					if(CellAllocation[Trackcw[t3][1]]==1){
						t1=t2; t2=t3; t3=Trackcw[t3][0];
						done=false;
					}
			}
					log << "t1= " << t1 << " t2= " << t2 << " t3= " << t3 << endl;
					log << "count t1= " << CellCount[t1] << " count t2= " << CellCount[t2] << " count t3= " << CellCount[t3] << endl;
					if(t.Length!=1){
						if((CellCount[t1]==CellCount[t2] && CellCount[t1]==CellCount[t3])
							|| (CellCount[t1]==CellCount[t2] && CellCount[t1]==(CellCount[t3]-1)))//three cells in a row have the same count
							
							return false;//a car is uncoupled
					}
			}
			
			
	
return true;
}



BEGIN_MESSAGE_MAP(CTrainOS, CFrameWnd)
	ON_WM_TIMER()
	ON_WM_PAINT ()
	ON_WM_CHAR()
END_MESSAGE_MAP()