// hello.h
#if !defined TRAINOS_H

#define TRAINOS_H

#include "Train.h"
#include <fstream>
#include <string>
using namespace std;

const int NUMCELL = 16;
const int TLENGTH = 3;
class CTrainOS : public CFrameWnd
{
public:
	CTrainOS();
	~CTrainOS();
	void OnTimer(UINT);
	void OnPaint();
	void ResourceManager(); // updates CellList and CellCount
						// Keeps track whether train is in process of going over a cell
	void Deallocate(int);//deallocates a cell when the train is done with it
	bool Allocate(int);//tries to allocate the next cell
	void AlocationManager(Train x, int photocell); /* allocates and deaclcates cells
												//	does not allocate turnouts because they are gotten to only
												//	through a photocell.  If the train can not get a photocell,
												//	it will not be able to access the turnout*/
	bool GetNextInstr(int & Speed, int & PC, int & Dir, int & Instr);//where to next? ie speed 4 phococell 6
	bool ExecuteInstr(int Speed, int pc, int Dir, int Instr);//can I go there?
	bool LoadTrack();
	void Turn_TO_On(int Cell);
	void Turn_TO_Off(int Cell);
	void Display_Arrays();
	bool Uncouple();
	bool Couple();
	bool GenerateDisInstr(int&, int&, int&, int&, int);//returns info about a specific instr
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	bool CheckCars();
private:
	CString x, y, z, mn;
	string Batch[100];
	int BatchCount, BatchUsed;//counts how many were in the file and how many were used already
	Train t, GHOST;//t is my train:  GHOST is the other train
	//ifstream fin;//to read from the batch file
	ofstream log;//write to a log file
	//int Speed, PC, Dir;//these are for getting instructions from batch
	int count;
	int CellAllocation[NUMCELL];
	int CellList[NUMCELL],//current state of the cells
		CellCount[NUMCELL], //number of cars to pass the cell
		CellCurList[NUMCELL],
		Change[NUMCELL];//photocells that have changed state since last check
	int Trackcc[NUMCELL][3];
	int Trackcw[NUMCELL][3];//lists to store photo # turnout order
					/*  The first column is the photocell number  the second column track[x][0] 
					is the is the cell gotten to when the turnout is on.  
					The third column is the photo gotten to by the turn out being off
					The next column is the turnout between the two cells.
					note: the layout below is incorrect but gives an idea of what the 
					structures will look like
						ClockWise			CClockWise
				  Cell Link1  link2 TO     cell  link1  link2  TO

					0	2	-1	1			0	8	-1	-1
					1	2	-1	1			1	10	 3	0
					2	7	-1	-1			2	1	 0	1
					3	1	-1	0			3	9	-1	-1
					4	6	-1	-1			4	5	-1	-1
					5	4	-1	-1			5	6	-1	-1
					6	12	-1	-1			6	11	-1	-1
					7	15	-1	2			7	2	-1	-1
					8	0	-1	-1			8	13	-1	4
					9	3	-1	-1			9	13	-1	4
					10	1	-1	5			10	-1	-1	-1
					11	6	-1	-1			11	14	-1	-1
					12	15	-1	2			12	5	-1	-1
					13	8	 9	4			13	15	-1	3
					14	11	-1	-1			14	15	-1	3
					15	13	14	3			15	12	 7	2
*/
	int Blocked;//which photocell it is blocked on: -1 it's not blocked
	int photoOrder[7];//order of cells for allocating the next one
	DECLARE_MESSAGE_MAP()
};

#endif