// hello.cpp - implementation of CHelloWindow
#include <afxwin.h>
#include <process.h>
#include "TrainOS.h"
//from Mr. Blahnik
#include "cstrtok.cpp"
#include "Getint.cpp"

#include "ResourceManager.h"
#include "ccr.h"
#include "DCC_comm.h"
#include "MyDcc.h"


/*****************************************
Manages the PhotoCells: Checks the current status of the cells
checks if the train is in the middle of coing over a cell.  It does this 
through CellCount[].  It updates the current status of the cells in CellList[].
*/
void CTrainOS::Deallocate(int c){
	
	if(CellAllocation[c]==2){//was allocated to something else(not the train)
		CellAllocation[c]=0;//photocell cleared and is ok to move toward
		CellCount[c]=0;
		if(Blocked==c){//give it to the train that was blocked on this cell
			CellAllocation[c]=1;
			Blocked=-1;
			t.Blocked=false;
		}
		
		
	}
	else if(CellCount[c]>=t.GetLength()){
		if(t.PCLast!=t.PCNext){//must have switched dirs for this to happen
								// don't want to deallocate what we are going toward
			//MessageBox("Deallocate");
			CellCount[t.PCLast]=0;//train is done with previous cell cell
			log << "Deallocated cell: " << t.PCLast << endl;
			CellAllocation[t.PCLast]=0;
			t.PCLast=c;
			/*for(int i=0;i<NUMCELL;i++){
				if(CellAllocation[i]==1)
					if(i!=t.PCHas &&i!=t.PCNext){//clean up photocells that have been missed
						CellAllocation[i]=0;
						CellCount[i]=0;
					}
			}*/
		}
		t.PCLast=c;

	}
	else{
		log << "Didn't deallocate cell: " << t.PCLast << " because count on cell " << 
			c << " was only " << CellCount[c] << endl;
	}
	if(Blocked==c)
	{
		Blocked=-1;//not blocked anymore...resource freed up
		CellAllocation[c]=1;//allocate cell to train
	}


}

//looks to alocate the next cell given an input of the current cell the train is over
//returns true if sucessful;
//or false if not and blocks the train



void CTrainOS::ResourceManager(){
int c;
	int Speed, PC, Dir, Instr, CellAct[NUMCELL];
	bool ok, ExecuteOk=true, Change=false, c1=false;
	//gets the current state of each photocell
	int i;
	
	
	for(c=0;c<NUMCELL;c++){//get a snap shot of photocells
		CellCurList[c]=Get_Sensor_Status(c);
	}

	for(c=0;c<NUMCELL;c++){//adjust counts here for new cars hitting cells;
		if(CellCurList[c]==1 && CellList[c]==0){//if a car just hit a cell
			if (CellAllocation[c]==1){//if that cell was the trains cell
				CellCount[c]++;//increase the count for that cell
				log << "count++ for cell: " << c << endl; 
				c1=true;
			}
		}
	}

	if(c1){
		log << "after getting snap shot\nCur Cell List: ";
		for(c=0;c<NUMCELL;c++)
			log << CellCurList[c] << " ";
		log << endl;
	}
	for(c=0;c<NUMCELL;c++){
		//i=Get_Sensor_Status(c);
		//CellAct[c]=i;
		//*******check to see if the cell is allocated to the train****
		//if(i==CellList[c]);
		if(CellCurList[c]!=CellList[c]){//see if the cell state changed
			Change=true;
			if(CellCurList[c]==0){//cleared a photocell
				log << "Car just left photocell: " << c << endl;
				Deallocate(c);//if count is correct, can deallocate the previous cell
				//log << "\nAfter Deallocatethe instr is: ";
				//log << "PCLast: " << t.PCLast << " PCHas: " << t.PCHas << endl;
			//	log << " PCNext: " << t.PCNext << endl;
						//	log << "Requested photocell #: " << PC << endl << endl; 

				if(Blocked==-1){
					ExecuteOk=ExecuteInstr(t.Speed, t.PCNext, t.Direction);
					//MyDCC_motor(t.ID, t.Direction, t.Speed);
				}

			}
			else if(CellCurList[c]==1){
				if (CellAllocation[c]==1){//check to see if it is my cell
					//CellCount[c]++;//increase count for that cell
					log << "After count++" << endl;
					Display_Arrays();
					if(CellCount[c]==1){//new train over the cell
						log << endl;
						Display_Arrays();
						log << "Hit Photocell #: " << c << endl;
						//t.PCLast=t.PCHas;
						t.PCHas=c;
						log << "PCLast: " << t.PCLast << " PCHas: " << t.PCHas << endl;
						if(Instr==2)//Instr to uncouple
							Uncouple();
						
						ok=GetNextInstr(Speed, PC, Dir, Instr);//where to next? ie speed 4 phococell 6
						if(ok){
							t.PCNext=PC;
							log << " PCNext: " << t.PCNext << endl;
							log << "Requested photocell #: " << PC << endl; 
							ExecuteOk=ExecuteInstr(Speed, PC, Dir);//can I go there?
							//MessageBox("after execute","");
						}
						else{
							MessageBox("batch ran out", "Bah!!!");
							log << "Can't get another Instruction" << endl;
							MyDCC_motor(t.ID, t.Direction, 0);
						}
					}
					
					log << "new car just hit photocell: " << c << endl;
					log << "Photocell count for cell: " << c << " is: " << CellCount[c] << endl;
				}//end if CellAllocation[c]==1)
				else{ 
					CellAllocation[c]=2;
					//******************other train over photocell***************
					//GetOtherDir(); //figure out which dir the other engine(GHOST) is going
					//AllocateOther();	//allocate possible photoS for the other engine
					//DeallocateOther();//deallocate ones the engin is not using anymore

				}//******************************************************
			
			}//end else if(i==1)
			
		}//end if(i!=CellList[c])
		
		//CellList[c]=i;
	}//end for
	for(c=0;c<NUMCELL;c++)
		CellList[c]=CellCurList[c];
	//display of arrays for now
	x="Current State: ";
	y="Cell Count: ";
	z="Allocation table: ";
	char s[10];
	char t[10];
	
	
	for (c=0;c<NUMCELL;c++){
		itoa(CellList[c],s,10);
		x+=s[0];
		x+=' ';
		itoa(CellCount[c],t,10);
		y+=t[0];
		y+=' ';
		itoa(CellAllocation[c],t,10);
		z+=t[0];
		z+=' ';
	}
	if(Change){
		log << endl << "Index:      ";
		for(c=0;c<NUMCELL;c++){
			log << c << " ";
		}
		log << endl << "Cell State: ";
		for(c=0;c<NUMCELL;c++){
			log << CellList[c];
			if(c<10)log << " ";
			else log << "  ";
		}
		log << endl << "Cell Count: ";
		for(c=0;c<NUMCELL;c++){
			log << CellCount[c];
			if(c<10)log << " ";
			else log << "  ";
		}
		log << endl << "Cell Alloc: ";
		for(c=0;c<NUMCELL;c++){
			log << CellAllocation[c];
			if(c<10)log << " ";
			else log << "  ";
		} 
		log << endl;
	}
	return;
}// end CellManager()

bool CTrainOS::GetNextInstr(int & Speed, int & PC, int & Dir, int & Instr){
	bool ok;
	string token;
	string Temp;
	//MessageBox("GetNextInstr","");
	//read cell then speed then dir
	if(BatchUsed>=BatchCount)BatchUsed=0;
	if(BatchUsed<BatchCount){
		Temp=Batch[BatchUsed];
		token=cstrtok(Temp," ");
		PC =Getint(token, ok);
		token=cstrtok(Temp," ");
		Speed =Getint(token, ok);
		token=cstrtok(Temp," ");
		Dir =Getint(token, ok);
		token=cstrtok(Temp," ");
		Instr =Getint(token, ok);
		BatchUsed++;
		log << "instruction gotten: " << BatchUsed-1 << endl;
		log << "pc: " << PC << "  speed: " << Speed << "  dir: " << Dir 
			<< " Instr: " << Instr << endl; 
		return true;
	}
	return false;

}

bool CTrainOS::ExecuteInstr(int Speed, int pc, int Dir, int Instr){
	bool state;
	/*************************************************************************************
	/* Start debugging here...The OS will not switch the turnouts correctly, some will. 
	a simple outside loop, TO 3 will turn, but 4 won't.  aiming for the figure 8, t2 will 
	not turn when the train goes over it the second time.
	*******************************************************************************/
	log << "PCLast: " << t.PCLast << " PCHas: " << t.PCHas << " PCNext: " << t.PCNext << endl;
	if(t.Direction!=Dir){
			log << endl << "****** Change Dir *******" << endl;
				//stop train
				MyDCC_motor(t.ID, t.Direction, 0);
				t.Direction=Dir;
				//CellAllocation[t.PCLast]=0;
				//t.PCLast=-1;
				Display_Arrays();
				log << endl;
				for(int i=0;i<NUMCELL;i++){
					if(CellCount[i]!=0){
						if(i==t.PCHas)
							CellCount[i]=t.Length-(CellCount[i]-1);
						else if(CellList[i]==1){
							log << i << " ";
							CellCount[i]=t.Length-(CellCount[i]-1);
						}
						else
							CellCount[i]=t.Length-(CellCount[i]);
						if(CellCount[i]<0)CellCount[i]=0;
					}
				//	if(i==t.PCHas) CellCount[i]=t.Length-(CellCount[i]-1);
				}
				log << endl;
				Display_Arrays();
				bool ok=true;
				while(CellCount[t.PCNext]!=0 && ok){
					ok=GetNextInstr(Speed, pc, Dir);
					t.PCNext=pc;
					t.Speed=Speed;
					t.Direction=Dir;
				}
				if(!ok) MessageBox("error on change direction");
				//temp=CellCount[t.PCLast];
				//CellCount[t.PCLast]=CellCount[t.PCNext];
				//CellCount[t.PCNext]=temp;
				Sleep(1500);//sleeps the train to allow it to stop before changing direction
			}
	if(CellAllocation[pc]==0 || CellAllocation[pc]==1){
		if(t.Direction==1){
			if(Trackcw[t.PCHas][0]==pc){//found on track next
				
				if(Trackcw[t.PCHas][2]!=-1){//if there is a turnout, change it to on
					Turn_TO_On(Trackcw[t.PCHas][2]);
					//TO_On(Trackcw[t.PCHas][2]);
					//log << "Toggled ON TO: " << Trackcw[t.PCHas][2] << endl; 
				}

				CellAllocation[pc]=1;//give the train the cell
			}
			else if(Trackcw[t.PCHas][1]==pc){//found on other brantch of track next
				
				//turn turnout to off
				if(Trackcw[t.PCHas][2]!=-1){//if there is a turnout, change it to off
					MyDCC_motor(t.ID, t.Direction, 0);
					Turn_TO_Off(Trackcw[t.PCHas][2]);
					//TO_Off(Trackcw[t.PCHas][2]);
					//log << "Toggled OFF TO: " << Trackcw[t.PCHas][2] << endl;
				}

				CellAllocation[pc]=1;
			}//else MessageBox("didn't allocate","");

		}else if(t.Direction==0){
			if(Trackcc[t.PCHas][0]==pc){//found on track next
				log << endl << "in Trackcc[t.PCHas][0]==pc)" << endl;
				//turn turnout to left
				if(Trackcc[t.PCHas][2]!=-1){//if there is a turnout, change it to the left
					Turn_TO_On(Trackcc[t.PCHas][2]);
					log << "Toggled ON TO: " << Trackcc[t.PCHas][2] << endl; 
				}
				CellAllocation[pc]=1;//give the train the cell
			}else if(Trackcc[t.PCHas][1]==pc){//found on other brantch of track next
				log << endl << "in Trackcc[t.PCHas][1]==pc)" << endl;
				//turn turnout to right
				if(Trackcc[t.PCHas][2]!=-1){//if there is a turnout, change it to the left
					
					Turn_TO_Off(Trackcc[t.PCHas][2]);
					log << "Toggled OFF TO: " << Trackcc[t.PCHas][2] << endl;
				}
				CellAllocation[pc]=1;
			}else log << "can't fine the photocell" << endl;
		}

			
		
	
		t.Speed=Speed;
		state= true; //train executed the instruction
		log << "Train ID: " << t.ID << " Direction: " << //log output
			t.Direction << " Speed: " << t.Speed << endl;
		MyDCC_motor(t.ID, t.Direction, t.Speed);

	}else if (CellAllocation[pc]==2){//something else has the cell
		t.Blocked=true;
		Blocked=pc;
		//stop train
		MyDCC_motor(t.ID, t.Direction, 0);
		//MessageBox("Blocked in exeinstr","");

		log << "Train Blocked on Photocell #: " << pc << endl;
		log << "Train ID: " << t.ID << " Direction: " << //log output
			t.Direction << " Speed: " << t.Speed << endl;
		//BatchUsed--;
		//if (BatchUsed==-1)
		//	BatchUsed=BatchCount;
		log << "BatchUsed: " << BatchUsed << endl;
		log << "Dir: " << Batch[BatchUsed] << endl;
		Blocked=pc;//set which pc blocked the train
		state= false; //couldn't execute the instruction, the train is blocked
	}	
	return state;
}

CTrainOS::CTrainOS()
{
	bool ok;
	Create(NULL, "Train OS", WS_OVERLAPPEDWINDOW,
		CRect(100, 100, 700, 800) );
	

	int PortStatus = Open_Ports(); 
	//open ports to communicate with photocells and turnouts

	int InitStatus = Initialize_Board(1, 0, 0, 0, 0);
	InitStatus = Initialize_Board(2, 1, 1, 1, 1);
	InitStatus = Initialize_Board(3, 1, 1, 1, 1);
    InitStatus = Initialize_Board(4, 1, 1, 1, 1);
	//Init the four green boards with the photocells and turnouts
	//starts the turnouts in correct default positions.	
	
	MyDCC_open("COM1");
	MyDCC_reset();

	for(int i=0;i<NUMCELL;i++){
		CellList[i]=0;
		CellCount[i]=0;
		CellAllocation[i]=0;
		CellCurList[i]=0;
	}

	ifstream fin;
	
	log.open("logfile.txt");
	fin.open("path.txt");
	if(!fin){
		MessageBox("File cannot be opened","");
	}else{
		BatchCount=0;
		while(!fin.eof()){
			getline(fin, Batch[BatchCount]);
			BatchCount++;
		}
		BatchUsed=0;
		fin.close();
	}
	log << "Number of intruuctions loaded: " << BatchCount << endl;
	ok=LoadTrack();
	if (!ok) MessageBox("Couldn't load file","");
	/**/ 
	CellAllocation[0]=1;//start going toward cell 0
	CellAllocation[8]=1;
	//CellAllocation[13]=1;
	CellCount[8]=5;
	//CellCount[13]=1;
	//CellAllocation[7]=2;
	
	count=0;
	
	t.ID=32;
	t.PCHas=8;
	t.PCLast=8;
	//t.PCLast=13;
	t.PCNext=0;
	t.Speed=4;
	t.Direction=1;
	MyDCC_motor(t.ID, t.Direction, t.Speed);//start the train
	/*for(int p=0;p<5;p++){
	TO_Off(p);
	
	}
	Sleep(1500);for(p=0;p<5;p++)log << Get_TO_Status(p) << " ";
	log << endl;*/
 SetTimer(1,100, NULL);
	
	
}

CTrainOS::~CTrainOS()
{
	MyDCC_motor(t.ID, t.Direction, 0);
	log.close();
	KillTimer(1);
	MyDCC_close();
	
}

void CTrainOS::OnTimer(UINT x){
	ResourceManager();
//	AlocationManager();
	
	
	
	//count++;
	Invalidate();

}

void CTrainOS::OnPaint(){
CPaintDC dc (this);
dc.TextOut(200, 200, x);
dc.TextOut(200, 300, y);
dc.TextOut(200, 400, z);
	//dc.TextOut(count, count, "hello");
}

bool CTrainOS::LoadTrack(){
	ifstream fin;
	ofstream fout;
	int temp;
	fout.open("test.txt");
	
	int i;
	fin.open("track.dat");
	if(!fin)
		return false;
	for(i=0;i<NUMCELL;i++){
		fin >> temp;
		Trackcw[i][0]= temp;
		fin >> temp;
		Trackcw[i][1] = temp;
		fin >> temp;
		Trackcw[i][2]= temp;
		}
	for(i=0;i<NUMCELL;i++){
		fin >> Trackcc[i][0] >> Trackcc[i][1] >> Trackcc[i][2];
		}

	for (i=0;i<NUMCELL;i++)
		fout << i << " " << Trackcw[i][0] << " " << Trackcw[i][1] << " " << Trackcw[i][2] << endl;
	for (i=0;i<NUMCELL;i++)
		fout << i << " " << Trackcc[i][0] << " " << Trackcc[i][1] << " " << Trackcc[i][2] << endl;
	//return true;

	fout.close();
	fin.close();
	return true;
}
void CTrainOS::Turn_TO_On(int Cell){
	bool ok;
	ok=false;
	switch(Cell){
		case 0:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 1:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 2:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 3:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 4:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		default:
			ok=false;
			break;
		}
	if(!ok)
		MyDCC_motor(t.ID, t.Direction, 0);//stop the train
	TO_On(Cell);
	while(!ok){
		switch(Cell){
		case 0:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 1:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 2:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 3:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 4:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		default:
			ok=false;
			break;
		}
	}
MyDCC_motor(t.ID, t.Direction, t.Speed);//start the train


	log << "Toggled ON TO: " << Trackcw[t.PCHas][2] << endl;
}
void CTrainOS::Turn_TO_Off(int Cell){
	bool ok;
	ok=false;
	switch(Cell){
		case 0:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 1:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 2:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 3:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 4:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		default:
			ok=false;
			break;
		}
	if(!ok)
		MyDCC_motor(t.ID, t.Direction, 0);//stop the train
	TO_Off(Cell);
	while(!ok){
		switch(Cell){
		case 0:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 1:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 2:
			if(Get_TO_Status(Cell)==1)
				ok=true;
			break;
		case 3:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		case 4:
			if(Get_TO_Status(Cell)==-1)
				ok=true;
			break;
		default:
			ok=false;
			break;
		}
	}
MyDCC_motor(t.ID, t.Direction, t.Speed);//start the train


	log << "Toggled ON TO: " << Trackcw[t.PCHas][2] << endl;
}

bool CTrainOS::Uncouple(){
	if(t.Direction!=1)
		log << "Ileagle direction for uncoupling\n";
		return false;
	MyDCC_motor(t.ID, t.Direction, 0);//stops the train
	Sleep(1500);//make sure the train is stopped
	MyDCC_motor(t.ID, 0, 4);
	Sleep(100);
	MyDCC_motor(t.ID, 1, 4);//push the uncoupled car
	
		/*loop till I get one car past the photocell, then stop, change dirs and get back to origional cell
		uncoupling should be finnished, subtract one from train length*/

}
void CTrainOS::Display_Arrays(){
	int c;
	log << endl << "Index:      ";
		for(c=0;c<NUMCELL;c++){
			log << c << " ";
		}
		
		log << endl << "Cell State: ";
		for(c=0;c<NUMCELL;c++){
			log << CellList[c];
			if(c<10)log << " ";
			else log << "  ";
		}
		log << endl << "Cell Count: ";
		for(c=0;c<NUMCELL;c++){
			log << CellCount[c];
			if(c<10)log << " ";
			else log << "  ";
		}
		log << endl << "Cell Alloc: ";
		for(c=0;c<NUMCELL;c++){
			log << CellAllocation[c];
			if(c<10)log << " ";
			else log << "  ";
		} 
		log << endl;
}

BEGIN_MESSAGE_MAP(CTrainOS, CFrameWnd)
	ON_WM_TIMER()
	ON_WM_PAINT ()
END_MESSAGE_MAP()