//                           cstrtok
//   Token processing asssociated with namespace strings
//                                              J Blahnik  Spring 2001
 
string cstrtok(string &data, string delims) {
//***************************************************************************
//   Returns the next token of "data".  Tokens are deliminted by chars
//   in "delims".  Note that "data" is altered on return.  (The token
//   returning is removed from "data".)
//   Returns "" if no more tokens in "data".
//
//     Typical usage:     do {
//                           token = cstrtok(data, " ./");
//                           if (token == "") break;  // no more
//                           cout << token;
//                        } while (true);
//
//    ********** INCLUDE usage order **********
//     #include "G:\cslib\stringfix"
//     using namespace std;
 
//     #include <iostream>
//     #include "G:\cslib\cstrtok"
//        {other includes}
//***************************************************************************
    int i,j;
    string tok;
    bool Adelim;
 
    tok = "";
 
    //   skip leading delims
    for(i=0; i<data.length(); i++) {
        Adelim = false;
        for (j=0; j<delims.length(); j++) {
            if (data[i] == delims[j]) {
                Adelim = true;
                break;
            }
        }
        if (! Adelim) break;  //   beginning of the token found
 
    }
 
    //   look for 1st terminating delimiter and build token as you go
    for(; i<data.length(); i++) {
        for (j=0; j<delims.length(); j++) {
            if (data[i] == delims[j]) {
                //   delim found.  End of token.
                data.erase(0,i);
                return (tok);
            }
        }
        tok = tok + data[i];
    }
    //   end-of-string found.  End of token.
    data.erase(0,i);
    return (tok);
}// cstrtok