//*******************************************************************
//                            GETINT
//                       visual C++ version
//*******************************************************************
 
using namespace std;
 
#include <limits.h>  //  for INT_MAX
 
//#define MAXINT  32767
//#define INT_MAX 2147483647  (2^31)-1
 
 
 
 
 
int Getint(string token, bool &ok) {
//********************************************************************
//   Returns the integer value of the token in "token".
//
//   PARAMETERS:
//   token - Input array that contains the integer value to be converted.
//           The data in 'token' is in character form.
//   ok    - returned as a status flag.
//                    =true, no errors found.
//                    =false, errors found, bad numeric in "token"
//********************************************************************
  int  val;          //  Accumulated return value
  int  num_digits;   //  number of digits in input number
  int  large;        //  largest max value
  int  rmdr;         //  remainder assoc. with "large"
  bool minus;        //  set true if minus sign found
  int  po;           //  current position of 'token' processing
 
   //***** Set max integer values before next digit processed
   large = INT_MAX / 10;
   rmdr  = INT_MAX % 10;
 
   if (token == "") { ok = false;   return(INT_MAX); }
 
   val = 0; // initialize return value
   num_digits = 0;
 
   //***** Skip leading blanks *****
   for (po=0; po<token.length(); po++)
      if(token[po] != ' ') break;
 
   //***** Check for an initial minus sign *****
   minus = false;
   if (token[po] == '-') {
      minus = true;
      po++;
   } // if
 
   //***** Process numeric part of the token, creating the integer
   //***** in "val" as you go
   ok = true;
   do {
      if (po >= token.length()) break;
 
      //   insure numeric
      if (token[po] < '0' || token[po] > '9') break;
 
      num_digits++;
 
      // Insure new value is <= INT_MAX
      if (val < large)
         val = val * 10 + (int)token[po] - (int)'0';
 
      else if ((val == large) && ((int)token[po]-(int)'0' <= rmdr))
            //   subtract 1st to avoid
         val = val * 10 - (int)'0' + (int)token[po];
 
      else { // ERROR .... overflow - ignore remaining digits
         val = INT_MAX;    ok = false;
         break;
      } // if
 
      po++;
   } while (true); // forever
 
   if (num_digits == 0) ok = false; // {no data}
   if (minus) return ( -val);
   else       return ( val);
} // Getint